/*
 * RegistrySerializer_impl.hpp
 *
 *  Created on: Feb 27, 2016
 *      Author: heber
 */

#ifndef REGISTRYSERIALIZER_IMPL_HPP_
#define REGISTRYSERIALIZER_IMPL_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include "RegistrySerializer.hpp"

#include <iostream>

#include "CodePatterns/Log.hpp"

template <class T>
void RegistrySerializer<T>::operator()()
{
  for (typename Registry<T>::const_iterator iter = instance.getBeginIter();
      iter != instance.getEndIter(); ++iter)
  {
    const T * const item = iter->second;
    LOG(1, "INFO: Now serializing " << name << ".");
    item->stream_to(to_serialize);
    to_serialize << std::endl;
  }
}

#endif /* REGISTRYSERIALIZER_IMPL_HPP_ */
